// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VTWE__Syms.h"


//======================

void VTWE::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VTWE::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VTWE::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VTWE::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VTWE::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VTWE__Syms* __restrict vlSymsp = static_cast<VTWE__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VTWE::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VTWE::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VTWE__Syms* __restrict vlSymsp = static_cast<VTWE__Syms*>(userp);
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VTWE::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VTWE__Syms* __restrict vlSymsp = static_cast<VTWE__Syms*>(userp);
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+131,"clk", false,-1);
        tracep->declBit(c+132,"res_n", false,-1);
        tracep->declBit(c+133,"lock", false,-1);
        tracep->declBit(c+134,"unlock", false,-1);
        tracep->declBus(c+135,"key", false,-1, 15,0);
        tracep->declQuad(c+136,"virt_addr_in", false,-1, 47,0);
        tracep->declBit(c+138,"virt_addr_in_vld", false,-1);
        tracep->declQuad(c+139,"data_from_memory", false,-1, 39,0);
        tracep->declBit(c+141,"data_from_memory_vld", false,-1);
        tracep->declBus(c+142,"mode", false,-1, 1,0);
        tracep->declQuad(c+143,"pte_root_addr", false,-1, 47,0);
        tracep->declBit(c+145,"locked", false,-1);
        tracep->declQuad(c+146,"phys_addr_out", false,-1, 47,0);
        tracep->declBit(c+148,"phys_addr_out_vld", false,-1);
        tracep->declQuad(c+149,"data_to_memory", false,-1, 47,0);
        tracep->declBit(c+151,"data_to_memory_vld", false,-1);
        tracep->declBit(c+152,"twe_active", false,-1);
        tracep->declBit(c+131,"TWE clk", false,-1);
        tracep->declBit(c+132,"TWE res_n", false,-1);
        tracep->declBit(c+133,"TWE lock", false,-1);
        tracep->declBit(c+134,"TWE unlock", false,-1);
        tracep->declBus(c+135,"TWE key", false,-1, 15,0);
        tracep->declQuad(c+136,"TWE virt_addr_in", false,-1, 47,0);
        tracep->declBit(c+138,"TWE virt_addr_in_vld", false,-1);
        tracep->declQuad(c+139,"TWE data_from_memory", false,-1, 39,0);
        tracep->declBit(c+141,"TWE data_from_memory_vld", false,-1);
        tracep->declBus(c+142,"TWE mode", false,-1, 1,0);
        tracep->declQuad(c+143,"TWE pte_root_addr", false,-1, 47,0);
        tracep->declBit(c+145,"TWE locked", false,-1);
        tracep->declQuad(c+146,"TWE phys_addr_out", false,-1, 47,0);
        tracep->declBit(c+148,"TWE phys_addr_out_vld", false,-1);
        tracep->declQuad(c+149,"TWE data_to_memory", false,-1, 47,0);
        tracep->declBit(c+151,"TWE data_to_memory_vld", false,-1);
        tracep->declBit(c+152,"TWE twe_active", false,-1);
        tracep->declBus(c+154,"TWE KEY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+155,"TWE KEY", false,-1, 15,0);
        tracep->declBus(c+156,"TWE VAXX_MODE_WIDTH", false,-1, 31,0);
        tracep->declBus(c+157,"TWE VA48_ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+158,"TWE VA48_INDEX_WIDTH", false,-1, 31,0);
        tracep->declBus(c+159,"TWE VA48_PTE_ENTRY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+160,"TWE VA48_PTE_PAGE_BASE_ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+161,"TWE VAXX_PTE_PAGE_STATUS_WIDTH", false,-1, 31,0);
        tracep->declBus(c+158,"TWE VA48_PTE_PAGE_OFFSET_WIDTH", false,-1, 31,0);
        tracep->declBus(c+162,"TWE VA48_PTE_OFFSET_SIZE", false,-1, 31,0);
        tracep->declBus(c+163,"TWE VA48_PTE_LEVEL0_HIGH", false,-1, 31,0);
        tracep->declBus(c+164,"TWE VA48_PTE_LEVEL0_LOW", false,-1, 31,0);
        tracep->declBus(c+165,"TWE VA48_PTE_LEVEL1_HIGH", false,-1, 31,0);
        tracep->declBus(c+166,"TWE VA48_PTE_LEVEL1_LOW", false,-1, 31,0);
        tracep->declBus(c+167,"TWE VA48_PTE_LEVEL2_HIGH", false,-1, 31,0);
        tracep->declBus(c+168,"TWE VA48_PTE_LEVEL2_LOW", false,-1, 31,0);
        tracep->declBus(c+169,"TWE VA48_PTE_LEVEL3_HIGH", false,-1, 31,0);
        tracep->declBus(c+158,"TWE VA48_PTE_LEVEL3_LOW", false,-1, 31,0);
        tracep->declBus(c+157,"TWE PA48_ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+158,"TWE PA48_INDEX_WIDTH", false,-1, 31,0);
        tracep->declBus(c+154,"TWE VA48_CAM_NUM_OF_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+170,"TWE VA48_CAM_ENTRY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+160,"TWE VA48_CAM_TAG_WIDTH", false,-1, 31,0);
        tracep->declArray(c+171,"TWE VA48_ZERO_PTE", false,-1, 71,0);
        tracep->declQuad(c+174,"TWE ZERO_DATA_TO_MEMORY", false,-1, 47,0);
        tracep->declQuad(c+174,"TWE ZERO_PHYS_ADDR_OUT", false,-1, 47,0);
        tracep->declArray(c+171,"TWE ZERO_CAM_ENTRY", false,-1, 71,0);
        tracep->declBus(c+41,"TWE STATE", false,-1, 2,0);
        tracep->declBus(c+3,"TWE NEXT_STATE", false,-1, 2,0);
        tracep->declBit(c+4,"TWE VA48_CAM_hit", false,-1);
        tracep->declBus(c+176,"TWE ras_key_int", false,-1, 31,0);
        tracep->declBit(c+177,"TWE ras_in_addr_val_int", false,-1);
        tracep->declQuad(c+174,"TWE ras_in_addr_int", false,-1, 47,0);
        tracep->declBit(c+177,"TWE ras_rd_int", false,-1);
        tracep->declBit(c+5,"TWE ras_out_addr_val_int", false,-1);
        tracep->declQuad(c+6,"TWE ras_out_addr_int", false,-1, 47,0);
        tracep->declBit(c+8,"TWE ras_locked_int", false,-1);
        tracep->declBit(c+9,"TWE ras_write_active_int", false,-1);
        tracep->declBit(c+10,"TWE ras_empty_int", false,-1);
        tracep->declBit(c+11,"TWE ras_full_int", false,-1);
        tracep->declArray(c+12,"TWE data_from_tlb", false,-1, 71,0);
        tracep->declBit(c+15,"TWE DO_IDLE", false,-1);
        tracep->declBit(c+16,"TWE DO_LOCK", false,-1);
        tracep->declBit(c+17,"TWE DO_UNLOCK", false,-1);
        tracep->declBit(c+153,"TWE IS_KEY_MATCH", false,-1);
        tracep->declBit(c+42,"TWE IS_LOCKED", false,-1);
        tracep->declBit(c+18,"TWE IS_TLB_HIT", false,-1);
        tracep->declBit(c+19,"TWE NEXT_LEVEL", false,-1);
        tracep->declBit(c+20,"TWE START_TWE", false,-1);
        tracep->declBit(c+21,"TWE VA48_CAM_rd", false,-1);
        tracep->declArray(c+22,"TWE VA48_CAM_rd_data", false,-1, 71,0);
        tracep->declBit(c+25,"TWE VA48_CAM_wr", false,-1);
        tracep->declArray(c+26,"TWE VA48_CAM_wr_data", false,-1, 71,0);
        tracep->declBus(c+178,"TWE VA48_CAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+179,"TWE VA48_CAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+180,"TWE VA48_CAM TAG_WIDTH", false,-1, 31,0);
        tracep->declBit(c+131,"TWE VA48_CAM clk", false,-1);
        tracep->declBit(c+132,"TWE VA48_CAM res_n", false,-1);
        tracep->declBit(c+21,"TWE VA48_CAM rd", false,-1);
        tracep->declBit(c+25,"TWE VA48_CAM wr", false,-1);
        tracep->declArray(c+26,"TWE VA48_CAM wr_data", false,-1, 71,0);
        tracep->declArray(c+22,"TWE VA48_CAM rd_data", false,-1, 71,0);
        tracep->declBit(c+4,"TWE VA48_CAM hit", false,-1);
        tracep->declBus(c+181,"TWE VA48_CAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+182,"TWE VA48_CAM ENTRY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+183,"TWE VA48_CAM ZERO_ADDR", false,-1, 3,0);
        tracep->declArray(c+171,"TWE VA48_CAM ZERO_DATA", false,-1, 71,0);
        {int i; for (i=0; i<16; i++) {
                tracep->declArray(c+43+i*3,"TWE VA48_CAM MEMORY", true,(i+0), 71,0);}}
        tracep->declBus(c+91,"TWE VA48_CAM HEAD", false,-1, 3,0);
        tracep->declBus(c+92,"TWE VA48_CAM HEAD_PLUS_1", false,-1, 3,0);
        tracep->declBus(c+29,"TWE VA48_CAM compare", false,-1, 15,0);
        tracep->declBus(c+1,"TWE VA48_CAM unnamedblk1 i", false,-1, 31,0);
        tracep->declBit(c+131,"TWE RAS16X48_K32 clk", false,-1);
        tracep->declBit(c+132,"TWE RAS16X48_K32 res_n", false,-1);
        tracep->declBit(c+133,"TWE RAS16X48_K32 lock", false,-1);
        tracep->declBit(c+134,"TWE RAS16X48_K32 unlock", false,-1);
        tracep->declBus(c+176,"TWE RAS16X48_K32 key", false,-1, 31,0);
        tracep->declBit(c+177,"TWE RAS16X48_K32 in_addr_val", false,-1);
        tracep->declQuad(c+174,"TWE RAS16X48_K32 in_addr", false,-1, 47,0);
        tracep->declBit(c+177,"TWE RAS16X48_K32 rd", false,-1);
        tracep->declBit(c+5,"TWE RAS16X48_K32 out_addr_val", false,-1);
        tracep->declQuad(c+6,"TWE RAS16X48_K32 out_addr", false,-1, 47,0);
        tracep->declBit(c+8,"TWE RAS16X48_K32 locked", false,-1);
        tracep->declBit(c+9,"TWE RAS16X48_K32 ras_write_active", false,-1);
        tracep->declBit(c+10,"TWE RAS16X48_K32 empty", false,-1);
        tracep->declBit(c+11,"TWE RAS16X48_K32 full", false,-1);
        tracep->declBus(c+154,"TWE RAS16X48_K32 RAS_SIZE", false,-1, 31,0);
        tracep->declBus(c+157,"TWE RAS16X48_K32 RAS_WIDTH", false,-1, 31,0);
        tracep->declBus(c+184,"TWE RAS16X48_K32 KEY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+176,"TWE RAS16X48_K32 KEY", false,-1, 31,0);
        tracep->declQuad(c+174,"TWE RAS16X48_K32 ZERO_ADDR", false,-1, 47,0);
        tracep->declBus(c+93,"TWE RAS16X48_K32 STATE", false,-1, 0,0);
        tracep->declBus(c+30,"TWE RAS16X48_K32 NEXT_STATE", false,-1, 0,0);
        tracep->declBit(c+31,"TWE RAS16X48_K32 RAS_STACK_status", false,-1);
        tracep->declBit(c+131,"TWE RAS16X48_K32 RAS_STACK_clk", false,-1);
        tracep->declBit(c+132,"TWE RAS16X48_K32 RAS_STACK_res_n", false,-1);
        tracep->declBit(c+32,"TWE RAS16X48_K32 RAS_STACK_wr", false,-1);
        tracep->declQuad(c+33,"TWE RAS16X48_K32 RAS_STACK_wr_data", false,-1, 47,0);
        tracep->declBit(c+35,"TWE RAS16X48_K32 RAS_STACK_rd", false,-1);
        tracep->declQuad(c+36,"TWE RAS16X48_K32 RAS_STACK_rd_data", false,-1, 47,0);
        tracep->declBit(c+94,"TWE RAS16X48_K32 RAS_STACK_empty", false,-1);
        tracep->declBit(c+95,"TWE RAS16X48_K32 RAS_STACK_full", false,-1);
        tracep->declBit(c+38,"TWE RAS16X48_K32 DO_IDLE", false,-1);
        tracep->declBit(c+39,"TWE RAS16X48_K32 DO_LOCK", false,-1);
        tracep->declBit(c+177,"TWE RAS16X48_K32 DO_READ_STACK", false,-1);
        tracep->declBit(c+40,"TWE RAS16X48_K32 DO_UNLOCK", false,-1);
        tracep->declBit(c+177,"TWE RAS16X48_K32 DO_WRITE_STACK", false,-1);
        tracep->declBit(c+185,"TWE RAS16X48_K32 IS_KEY_MATCH", false,-1);
        tracep->declBus(c+186,"TWE RAS16X48_K32 RAS_STACK data_width", false,-1, 31,0);
        tracep->declBus(c+179,"TWE RAS16X48_K32 RAS_STACK num_of_entries", false,-1, 31,0);
        tracep->declBus(c+187,"TWE RAS16X48_K32 RAS_STACK addr_width", false,-1, 31,0);
        tracep->declBit(c+131,"TWE RAS16X48_K32 RAS_STACK clk", false,-1);
        tracep->declBit(c+132,"TWE RAS16X48_K32 RAS_STACK res_n", false,-1);
        tracep->declBit(c+35,"TWE RAS16X48_K32 RAS_STACK rd", false,-1);
        tracep->declBit(c+32,"TWE RAS16X48_K32 RAS_STACK wr", false,-1);
        tracep->declQuad(c+33,"TWE RAS16X48_K32 RAS_STACK wr_data", false,-1, 47,0);
        tracep->declQuad(c+36,"TWE RAS16X48_K32 RAS_STACK rd_data", false,-1, 47,0);
        tracep->declBit(c+94,"TWE RAS16X48_K32 RAS_STACK empty", false,-1);
        tracep->declBit(c+95,"TWE RAS16X48_K32 RAS_STACK full", false,-1);
        tracep->declBus(c+183,"TWE RAS16X48_K32 RAS_STACK ZERO_ADDR", false,-1, 3,0);
        tracep->declQuad(c+174,"TWE RAS16X48_K32 RAS_STACK ZERO_DATA", false,-1, 47,0);
        {int i; for (i=0; i<16; i++) {
                tracep->declQuad(c+96+i*2,"TWE RAS16X48_K32 RAS_STACK MEMORY", true,(i+0), 47,0);}}
        tracep->declBus(c+128,"TWE RAS16X48_K32 RAS_STACK HEAD", false,-1, 3,0);
        tracep->declBus(c+129,"TWE RAS16X48_K32 RAS_STACK HEAD_PLUS_1", false,-1, 3,0);
        tracep->declBus(c+130,"TWE RAS16X48_K32 RAS_STACK HEAD_MINUS_1", false,-1, 3,0);
        tracep->declBus(c+2,"TWE RAS16X48_K32 RAS_STACK i", false,-1, 31,0);
    }
}

void VTWE::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VTWE::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VTWE__Syms* __restrict vlSymsp = static_cast<VTWE__Syms*>(userp);
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VTWE::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VTWE__Syms* __restrict vlSymsp = static_cast<VTWE__Syms*>(userp);
    VTWE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Variables
    WData/*95:0*/ __Vtemp81[3];
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->TWE__DOT__VA48_CAM__DOT__unnamedblk1__DOT__i),32);
        tracep->fullIData(oldp+2,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__i),32);
        tracep->fullCData(oldp+3,(vlTOPp->TWE__DOT__NEXT_STATE),3);
        tracep->fullBit(oldp+4,(vlTOPp->TWE__DOT__VA48_CAM_hit));
        tracep->fullBit(oldp+5,(vlTOPp->TWE__DOT__ras_out_addr_val_int));
        tracep->fullQData(oldp+6,(vlTOPp->TWE__DOT__ras_out_addr_int),48);
        tracep->fullBit(oldp+8,(vlTOPp->TWE__DOT__ras_locked_int));
        tracep->fullBit(oldp+9,(vlTOPp->TWE__DOT__ras_write_active_int));
        tracep->fullBit(oldp+10,(vlTOPp->TWE__DOT__ras_empty_int));
        tracep->fullBit(oldp+11,(vlTOPp->TWE__DOT__ras_full_int));
        tracep->fullWData(oldp+12,(vlTOPp->TWE__DOT__data_from_tlb),72);
        tracep->fullBit(oldp+15,(vlTOPp->TWE__DOT__DO_IDLE));
        tracep->fullBit(oldp+16,(vlTOPp->TWE__DOT__DO_LOCK));
        tracep->fullBit(oldp+17,(vlTOPp->TWE__DOT__DO_UNLOCK));
        tracep->fullBit(oldp+18,(vlTOPp->TWE__DOT__IS_TLB_HIT));
        tracep->fullBit(oldp+19,(vlTOPp->TWE__DOT__NEXT_LEVEL));
        tracep->fullBit(oldp+20,(vlTOPp->TWE__DOT__START_TWE));
        tracep->fullBit(oldp+21,(vlTOPp->TWE__DOT__VA48_CAM_rd));
        tracep->fullWData(oldp+22,(vlTOPp->TWE__DOT__VA48_CAM_rd_data),72);
        tracep->fullBit(oldp+25,(vlTOPp->TWE__DOT__VA48_CAM_wr));
        tracep->fullWData(oldp+26,(vlTOPp->TWE__DOT__VA48_CAM_wr_data),72);
        tracep->fullSData(oldp+29,(vlTOPp->TWE__DOT__VA48_CAM__DOT__compare),16);
        tracep->fullBit(oldp+30,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__NEXT_STATE));
        tracep->fullBit(oldp+31,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_status));
        tracep->fullBit(oldp+32,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_wr));
        tracep->fullQData(oldp+33,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_wr_data),48);
        tracep->fullBit(oldp+35,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd));
        tracep->fullQData(oldp+36,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK_rd_data),48);
        tracep->fullBit(oldp+38,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__DO_IDLE));
        tracep->fullBit(oldp+39,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__DO_LOCK));
        tracep->fullBit(oldp+40,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__DO_UNLOCK));
        tracep->fullCData(oldp+41,(vlTOPp->TWE__DOT__STATE),3);
        tracep->fullBit(oldp+42,((7U == (IData)(vlTOPp->TWE__DOT__STATE))));
        tracep->fullWData(oldp+43,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[0]),72);
        tracep->fullWData(oldp+46,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[1]),72);
        tracep->fullWData(oldp+49,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[2]),72);
        tracep->fullWData(oldp+52,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[3]),72);
        tracep->fullWData(oldp+55,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[4]),72);
        tracep->fullWData(oldp+58,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[5]),72);
        tracep->fullWData(oldp+61,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[6]),72);
        tracep->fullWData(oldp+64,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[7]),72);
        tracep->fullWData(oldp+67,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[8]),72);
        tracep->fullWData(oldp+70,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[9]),72);
        tracep->fullWData(oldp+73,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[10]),72);
        tracep->fullWData(oldp+76,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[11]),72);
        tracep->fullWData(oldp+79,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[12]),72);
        tracep->fullWData(oldp+82,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[13]),72);
        tracep->fullWData(oldp+85,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[14]),72);
        tracep->fullWData(oldp+88,(vlTOPp->TWE__DOT__VA48_CAM__DOT__MEMORY[15]),72);
        tracep->fullCData(oldp+91,(vlTOPp->TWE__DOT__VA48_CAM__DOT__HEAD),4);
        tracep->fullCData(oldp+92,((0xfU & ((IData)(1U) 
                                            + (IData)(vlTOPp->TWE__DOT__VA48_CAM__DOT__HEAD)))),4);
        tracep->fullBit(oldp+93,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__STATE));
        tracep->fullBit(oldp+94,((0U == (IData)(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD))));
        tracep->fullBit(oldp+95,((0xfU == (IData)(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD))));
        tracep->fullQData(oldp+96,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[0]),48);
        tracep->fullQData(oldp+98,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[1]),48);
        tracep->fullQData(oldp+100,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[2]),48);
        tracep->fullQData(oldp+102,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[3]),48);
        tracep->fullQData(oldp+104,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[4]),48);
        tracep->fullQData(oldp+106,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[5]),48);
        tracep->fullQData(oldp+108,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[6]),48);
        tracep->fullQData(oldp+110,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[7]),48);
        tracep->fullQData(oldp+112,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[8]),48);
        tracep->fullQData(oldp+114,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[9]),48);
        tracep->fullQData(oldp+116,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[10]),48);
        tracep->fullQData(oldp+118,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[11]),48);
        tracep->fullQData(oldp+120,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[12]),48);
        tracep->fullQData(oldp+122,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[13]),48);
        tracep->fullQData(oldp+124,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[14]),48);
        tracep->fullQData(oldp+126,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__MEMORY[15]),48);
        tracep->fullCData(oldp+128,(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD),4);
        tracep->fullCData(oldp+129,((0xfU & ((IData)(1U) 
                                             + (IData)(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD)))),4);
        tracep->fullCData(oldp+130,((0xfU & ((IData)(vlTOPp->TWE__DOT__RAS16X48_K32__DOT__RAS_STACK__DOT__HEAD) 
                                             - (IData)(1U)))),4);
        tracep->fullBit(oldp+131,(vlTOPp->clk));
        tracep->fullBit(oldp+132,(vlTOPp->res_n));
        tracep->fullBit(oldp+133,(vlTOPp->lock));
        tracep->fullBit(oldp+134,(vlTOPp->unlock));
        tracep->fullSData(oldp+135,(vlTOPp->key),16);
        tracep->fullQData(oldp+136,(vlTOPp->virt_addr_in),48);
        tracep->fullBit(oldp+138,(vlTOPp->virt_addr_in_vld));
        tracep->fullQData(oldp+139,(vlTOPp->data_from_memory),40);
        tracep->fullBit(oldp+141,(vlTOPp->data_from_memory_vld));
        tracep->fullCData(oldp+142,(vlTOPp->mode),2);
        tracep->fullQData(oldp+143,(vlTOPp->pte_root_addr),48);
        tracep->fullBit(oldp+145,(vlTOPp->locked));
        tracep->fullQData(oldp+146,(vlTOPp->phys_addr_out),48);
        tracep->fullBit(oldp+148,(vlTOPp->phys_addr_out_vld));
        tracep->fullQData(oldp+149,(vlTOPp->data_to_memory),48);
        tracep->fullBit(oldp+151,(vlTOPp->data_to_memory_vld));
        tracep->fullBit(oldp+152,(vlTOPp->twe_active));
        tracep->fullBit(oldp+153,((0xaffaU == (IData)(vlTOPp->key))));
        tracep->fullIData(oldp+154,(0x10U),32);
        tracep->fullSData(oldp+155,(0xaffaU),16);
        tracep->fullIData(oldp+156,(2U),32);
        tracep->fullIData(oldp+157,(0x30U),32);
        tracep->fullIData(oldp+158,(0xcU),32);
        tracep->fullIData(oldp+159,(0x28U),32);
        tracep->fullIData(oldp+160,(0x24U),32);
        tracep->fullIData(oldp+161,(4U),32);
        tracep->fullIData(oldp+162,(9U),32);
        tracep->fullIData(oldp+163,(0x2fU),32);
        tracep->fullIData(oldp+164,(0x27U),32);
        tracep->fullIData(oldp+165,(0x26U),32);
        tracep->fullIData(oldp+166,(0x1eU),32);
        tracep->fullIData(oldp+167,(0x1dU),32);
        tracep->fullIData(oldp+168,(0x15U),32);
        tracep->fullIData(oldp+169,(0x14U),32);
        tracep->fullIData(oldp+170,(0x48U),32);
        __Vtemp81[0U] = 0U;
        __Vtemp81[1U] = 0U;
        __Vtemp81[2U] = 0U;
        tracep->fullWData(oldp+171,(__Vtemp81),72);
        tracep->fullQData(oldp+174,(0ULL),48);
        tracep->fullIData(oldp+176,(0U),32);
        tracep->fullBit(oldp+177,(0U));
        tracep->fullIData(oldp+178,(0x48U),32);
        tracep->fullIData(oldp+179,(0x10U),32);
        tracep->fullIData(oldp+180,(0x24U),32);
        tracep->fullIData(oldp+181,(4U),32);
        tracep->fullIData(oldp+182,(0x24U),32);
        tracep->fullCData(oldp+183,(0U),4);
        tracep->fullIData(oldp+184,(0x20U),32);
        tracep->fullBit(oldp+185,(1U));
        tracep->fullIData(oldp+186,(0x30U),32);
        tracep->fullIData(oldp+187,(4U),32);
    }
}
